using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_frmReports : System.Web.UI.Page
{
    clsUser_Logic objUser = new clsUser_Logic();
    clsDocuments_Logic objDocument = new clsDocuments_Logic();
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsCategory_Logic objCategory = new clsCategory_Logic();
    private string strError = "No Data Available";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            this.txtPageSize.Text = "10";

            BindUsers();
            BindCategory();
            BindStatus();
            BindData();
        }
        GMDPFromDate.Attributes.Add("readonly", "readonly()");
        GMDPToDate.Attributes.Add("readonly", "readonly()");

    }

    void BindData()
    {
        if (ddlUserName.SelectedItem.Text != "Select")
        {
            objDocument.UserName = ddlUserName.SelectedItem.Text;
        }
        objDocument.CategoryId = Convert.ToInt32(ddlCategory.SelectedItem.Value.ToString());
        objDocument.StatusId  = Convert.ToInt32(ddlStatus.SelectedItem.Value.ToString());
        if (GMDPFromDate.DateString != "")
        {
            objDocument.FromSubmittedDate = GMDPFromDate.DateString;
        }
        if (GMDPToDate.DateString != "")
        {
            objDocument.ToSubmittedDate = GMDPToDate.DateString;
        }
        objDocument.Sort_On = "";
        if (ViewState["Sort_On"] != null)
            objDocument.Sort_On = ViewState["Sort_On"].ToString() + " " + ViewState["Sort_By"].ToString();
        lblError.Visible = false;
        DataSet dsTemp = objDocument.GetDocument();
        DataTable dtTemp = dsTemp.Tables[0];
        if (dtTemp.Rows.Count > 0)
        {
            lblError.Visible = false;
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = strError;
        }
        if (this.txtPageSize.Text != "")
        {
            if (System.Convert.ToInt32(this.txtPageSize.Text) > 0)
            {
                this.gvReports.PageSize = System.Convert.ToInt32(this.txtPageSize.Text);
            }
        }
        gvReports.DataSource = dtTemp;
        gvReports.DataBind();
        if (dtTemp.Rows.Count == 0)
        {
            this.Lbl_Pageinfo.Visible = false;
        }
        else
        {
            Int16 intTo;
            Int16 intFrom;
            if (gvReports.PageSize * (gvReports.PageIndex + 1) < dtTemp.Rows.Count)
            {
                intTo = System.Convert.ToInt16(gvReports.PageSize * (gvReports.PageIndex + 1));
            }
            else
            {
                intTo = System.Convert.ToInt16(dtTemp.Rows.Count);
            }
            intFrom = System.Convert.ToInt16((gvReports.PageSize * gvReports.PageIndex) + 1);
            this.Lbl_Pageinfo.Text = "Record(s) " + intFrom + " to " + intTo + " of " + dtTemp.Rows.Count;
            this.Lbl_Pageinfo.Visible = true;
        }
    }

    void BindUsers()
    {
        DataSet dsUsers = objUser.GetUser();
        ddlUserName.DataSource = dsUsers.Tables[0];
        ddlUserName.DataTextField = "UserName";
        ddlUserName.DataValueField = "UserId";
        ddlUserName.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlUserName.Items.Insert(0, li);
    }
    void BindCategory()
    {
        DataSet dsCategory = objCategory.GetCategory();
        ddlCategory.DataSource = dsCategory.Tables[0];
        ddlCategory.DataTextField = "CategoryName";
        ddlCategory.DataValueField = "CategoryId";
        ddlCategory.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlCategory.Items.Insert(0, li);
    }
    void BindStatus()
    {
        DataSet dsStatus = objCommon.GetStatusName();
        ddlStatus.DataSource = dsStatus.Tables[0];
        ddlStatus.DataTextField = "StatusName";
        ddlStatus.DataValueField = "StatusId";
        ddlStatus.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlStatus.Items.Insert(0, li);
    }
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        if (GMDPFromDate.DateString != "" && GMDPToDate.DateString != "")
        {
            if (GMDPFromDate.Date > GMDPToDate.Date)
            {
                lblError.Text = "To Date must be greater than From date";
                lblError.Visible = true;
                return;
            }
        }
        strError = "No data matching with your searching criteria";
        gvReports.PageIndex = 0;
        BindData();
    }
    protected void gvReports_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        if (ViewState["Sort_On"] != null)
            objDocument.Sort_On = ViewState["Sort_On"].ToString();
        else
            objDocument.Sort_On = "";
        gvReports.PageIndex = e.NewPageIndex;
        BindData();
    }
    protected void gvReports_Sorting(object sender, GridViewSortEventArgs e)
    {
        objDocument.Sort_On = e.SortExpression;
        ViewState["Sort_On"] = objDocument.Sort_On;
        if (ViewState["Sort_By"] == null)
            ViewState["Sort_By"] = "Asc";
        if (ViewState["Sort_By"].ToString() == "Asc")
        {
            ViewState["Sort_By"] = "Desc";
        }
        else
        {
            ViewState["Sort_By"] = "Asc";
        }
        BindData();
    }
    protected void btnExportToExcel_Click(object sender, EventArgs e)
    {
        Response.Clear();
        Response.AddHeader("content-disposition", "attachment;filename=DocumentReport.xls");
        Response.Charset = "";
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        Response.ContentType = "application/vnd.ms-excel";
        System.IO.StringWriter stringWrite = new System.IO.StringWriter();
        System.Web.UI.HtmlTextWriter htmlWrite = new HtmlTextWriter(stringWrite);
        gvReports.RenderControl(htmlWrite);
        Response.Write(stringWrite.ToString());
        Response.End();
    }
    public override void VerifyRenderingInServerForm(Control control)
    {

    }
    protected void btnExportToPDF_Click(object sender, EventArgs e)
    {
        Response.Clear();
        Response.AddHeader("content-disposition", "attachment;filename=DocumentReport.pdf");
        Response.Charset = "";
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        Response.ContentType = "application/pdf";
        System.IO.StringWriter stringWrite = new System.IO.StringWriter();
        System.Web.UI.HtmlTextWriter htmlWrite = new HtmlTextWriter(stringWrite);
        gvReports.RenderControl(htmlWrite);
        Response.Write(stringWrite.ToString());
        Response.End();
    }
}
