using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_frmManageCategory : System.Web.UI.Page
{
    private clsCategory_Logic objCategory = new clsCategory_Logic();
    private string strError = "No Data Available";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["AdminId"] == null)
        {
            Response.Redirect("frmAdminLogin.aspx");
        }
        else
        {
        }
        if (!Page.IsPostBack)
        {
            this.txtPageSize.Text = "10";
            BindData();
        }
        string Msg = "Do you want to delete this data?";
        btnDelete.Attributes.Add("onClick", "return confirm('" + Msg + "');");
    }

    private void BindData()
    {
        try{
        objCategory.CategoryName = txtCategoryName.Text.Trim();
        objCategory.Sort_On = "";
        if (ViewState["Sort_On"] != null)
            objCategory.Sort_On = ViewState["Sort_On"].ToString() + " " + ViewState["Sort_By"].ToString();
        lblError.Visible = false;
        DataSet dsTemp = objCategory.GetCategory();
        DataTable dtTemp = dsTemp.Tables[0];
        if (dtTemp.Rows.Count > 0)
        {
            lblError.Visible = false;
            btnDelete.Visible = true;
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = strError;
            btnDelete.Visible = false;
        }
        if (this.txtPageSize.Text != "")
        {
            if (System.Convert.ToInt32(this.txtPageSize.Text) > 0)
            {
                this.gvCategory.PageSize = System.Convert.ToInt32(this.txtPageSize.Text);
            }
        }
        gvCategory.DataSource = dtTemp;
        gvCategory.DataBind();
        if (dtTemp.Rows.Count == 0)
        {
            this.Lbl_Pageinfo.Visible = false;
        }
        else
        {
            Int16 intTo;
            Int16 intFrom;
            if (gvCategory.PageSize * (gvCategory.PageIndex + 1) < dtTemp.Rows.Count)
            {
                intTo = System.Convert.ToInt16(gvCategory.PageSize * (gvCategory.PageIndex + 1));
            }
            else
            {
                intTo = System.Convert.ToInt16(dtTemp.Rows.Count);
            }
            intFrom = System.Convert.ToInt16((gvCategory.PageSize * gvCategory.PageIndex) + 1);
            this.Lbl_Pageinfo.Text = "Record(s) " + intFrom + " to " + intTo + " of " + dtTemp.Rows.Count;
            this.Lbl_Pageinfo.Visible = true;
        }
        }
    catch(Exception ex)
     {
         lblError.Text = ex.Message;
         lblError.Visible = true;
     }
    }
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        strError = "No data matching with your searching criteria";
        gvCategory.PageIndex = 0;
        BindData(); 
    }
    protected void btnAdd_Click(object sender, EventArgs e)
    {
        Response.Redirect("frmAddCategory.aspx");
    }
    protected void btnDelete_Click(object sender, EventArgs e)
    {
        if (Request["Cbx_CategoryId"] == null)
        {
            lblError.Text = "Please select at least one to delete.";
            lblError.Visible = true;
        }
        else
        {
            objCategory.DeleteCategory(Request["Cbx_CategoryId"].ToString());
            lblError.Visible = false;
            BindData();

        }
    }
    protected void gvCategory_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        if (ViewState["Sort_On"] != null)
            objCategory.Sort_On = ViewState["Sort_On"].ToString();
        else
            objCategory.Sort_On = "";
        gvCategory.PageIndex = e.NewPageIndex;
        BindData();
    }
    protected void gvCategory_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName.ToUpper() == "UPDATE")
        {
            Response.Redirect("frmUpdateCategory.aspx?Id=" + e.CommandArgument.ToString());
        }
    }
    protected void gvCategory_SelectedIndexChanged(object sender, EventArgs e)
    {

    }
    protected void gvCategory_Sorting(object sender, GridViewSortEventArgs e)
    {
        objCategory.Sort_On = e.SortExpression;
        ViewState["Sort_On"] = objCategory.Sort_On;
        if (ViewState["Sort_By"] == null)
            ViewState["Sort_By"] = "Asc";
        if (ViewState["Sort_By"].ToString() == "Asc")
        {
            ViewState["Sort_By"] = "Desc";
        }
        else
        {
            ViewState["Sort_By"] = "Asc";
        }

        BindData();
    }
}
