using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Admin_frmMemberReport : System.Web.UI.Page
{
    clsUser_Logic objUser = new clsUser_Logic();
    private string strError = "No Data Available";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
           BindData();
        }
    }
    void BindData()
    {
        lblError.Visible = false;
        if (GMDPFromDate.DateString != "")
        {
            objUser.FromRegisteredDate = GMDPFromDate.DateString;
        }
        if (GMDPToDate.DateString != "")
        {
            objUser.ToRegisteredDate = GMDPToDate.DateString;
        }

        DataSet dsTemp = objUser.GetUser();
        DataTable dtTemp = dsTemp.Tables[0];
        if (dtTemp.Rows.Count > 0)
        {
            lblError.Visible = false;
            btnExportToExcel.Visible = true;
            btnExportToPDF.Visible = true;
            Button1.Visible = true;
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = strError;
            btnExportToExcel.Visible = false;
            btnExportToPDF.Visible = false;
            Button1.Visible = false;
        }
        gvUser.DataSource = dtTemp;
        gvUser.DataBind();  
      }

    protected void btnExportToExcel_Click(object sender, EventArgs e)
    {
        Response.Clear();
        Response.AddHeader("content-disposition", "attachment;filename=DocumentReport.xls");
        Response.Charset = "";
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        Response.ContentType = "application/vnd.ms-excel";
        System.IO.StringWriter stringWrite = new System.IO.StringWriter();
        System.Web.UI.HtmlTextWriter htmlWrite = new HtmlTextWriter(stringWrite);
        gvUser.RenderControl(htmlWrite);
        Response.Write(stringWrite.ToString());
        Response.End();
    }
    protected void btnExportToPDF_Click(object sender, EventArgs e)
    {
        Response.Clear();
        Response.AddHeader("content-disposition", "attachment;filename=DocumentReport.pdf");
        Response.Charset = "";
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        Response.ContentType = "application/pdf";
        System.IO.StringWriter stringWrite = new System.IO.StringWriter();
        System.Web.UI.HtmlTextWriter htmlWrite = new HtmlTextWriter(stringWrite);
        gvUser.RenderControl(htmlWrite);
        Response.Write(stringWrite.ToString());
        Response.End();
    }
    public override void VerifyRenderingInServerForm(Control control)
    {

    }
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        if (GMDPFromDate.DateString != "" && GMDPToDate.DateString != "")
        {
            if (GMDPFromDate.Date > GMDPToDate.Date)
            {
                lblError.Text = "To Date must be greater than From date";
                lblError.Visible = true;
                //return;
            }
        }
        strError = "No data matching with your searching criteria";
        gvUser.PageIndex = 0;
        BindData();
    }
  
}
