using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.ApplicationBlocks.Data;
using System.Data.SqlClient;
/// <summary>
/// Summary description for clsDocuments_Logic
/// </summary>
public class clsDocuments_Logic
{
    int _DocumentId, _UserId, _StatusId, _CategoryId;
    string _DocumentTitle, _UserName, _ShortDesc, _FullDesc, _DocumentUpload, _SubmittedBy, _KeyWords, _FromSubmittedDate, _ToSubmittedDate;
    DateTime _SubmittedDate;
    public string Sort_On;
    public string StatusName = "";
    public string CategoryName = "";
	public clsDocuments_Logic()
	{
        _SubmittedDate = DateTime.Now;
	}
    public int DecumentId
    {
        get { return _DocumentId; }
        set { _DocumentId = value; }
    }
    public int UserId
    {
        get { return _UserId; }
        set { _UserId = value; }
    }
    public int StatusId
    {
        get { return _StatusId; }
        set { _StatusId = value; }
    }
    public int CategoryId
    {
        get { return _CategoryId; }
        set { _CategoryId = value; }
    }
    public string UserName
    {
        get { return _UserName; }
        set { _UserName = value; }
    }
    public string DocumentTitle
    {
        get { return _DocumentTitle; }
        set { _DocumentTitle = value; }
    }
    public string ShortDesc
    {
        get { return _ShortDesc; }
        set { _ShortDesc = value; }
    }
    public string FullDesc
    {
        get { return _FullDesc; }
        set { _FullDesc = value; }
    }
    public string DocumentUpload
    {
        get { return _DocumentUpload; }
        set { _DocumentUpload = value; }
    }
    public string SubmittedBy
    {
        get { return _SubmittedBy; }
        set { _SubmittedBy = value; }
    }
    public string KeyWords
    {
        get { return _KeyWords; }
        set { _KeyWords = value; }
    }
    public DateTime SubmittedDate
    {
        get { return _SubmittedDate; }
        set { _SubmittedDate = value; }
    }
   
    public string FromSubmittedDate
    {
        get { return _FromSubmittedDate; }
        set { _FromSubmittedDate = value; }
    }
    public string ToSubmittedDate
    {
        get { return _ToSubmittedDate; }
        set { _ToSubmittedDate = value; }
    }

    public DataSet GetDocument()
    {
        string strSql = string.Empty;
        strSql = "select * from tbl_DocumentDetails dd,tbl_DocumentCategory dc,tbl_Status s,tbl_UserLoginAccount u where dd.StatusId=s.StatusId and dd.UserId=u.UserId and dd.CategoryId=dc.CategoryId";
        if(_UserId!=0)
            strSql += " and dd.UserId=" + _UserId;
        if (_StatusId != 0)
            strSql += " and s.StatusId=" + _StatusId;
        if (_CategoryId != 0)
            strSql += " and dd.CategoryId=" + _CategoryId;

        if (!string.IsNullOrEmpty(_UserName))
            strSql += " and u.UserName='" + _UserName + "'";

        if (!string.IsNullOrEmpty(_FromSubmittedDate))
            strSql += " and dd.SubmittedDate >'" + Convert.ToDateTime(_FromSubmittedDate) + "'";

        if (!string.IsNullOrEmpty(_ToSubmittedDate))
            strSql += " and dd.SubmittedDate <'" + Convert.ToDateTime(_ToSubmittedDate) + "'";

       if (!string.IsNullOrEmpty(_DocumentTitle))
           strSql += " and DocumentTitle like '%" + _DocumentTitle + "%'";
        if (!string.IsNullOrEmpty(Sort_On))
        {
            strSql = strSql + " ORDER BY " + Sort_On;
        }
        else
        {
            strSql = strSql + " Order By DocumentTitle";
        }
       DataSet dsTemp;
        dsTemp = SqlHelper.ExecuteDataset(ClsConnectionString.getConnectionString(), CommandType.Text, strSql);
        return dsTemp;
    }
    public void GetDocumentDetails()
    {
        string strSql = string.Empty;
        strSql += "select * from tbl_DocumentDetails dd,tbl_DocumentCategory dc,tbl_Status s,tbl_UserLoginAccount u where dd.StatusId=s.StatusId and dd.UserId=u.UserId and dd.CategoryId=dc.CategoryId";
        strSql += " and dd.DocumentId=" + _DocumentId;
        if(_UserId!=0)
        strSql += " and dd.UserId=" + _UserId;
        DataSet ds = SqlHelper.ExecuteDataset(ClsConnectionString.getConnectionString(), CommandType.Text, strSql);
        DataRowCollection drc = ds.Tables[0].Rows;
        if (drc.Count > 0)
        {
            _StatusId = Convert.ToInt32(drc[0]["StatusId"].ToString());
            _CategoryId = Convert.ToInt32(drc[0]["CategoryId"].ToString());
            _DocumentTitle = drc[0]["DocumentTitle"].ToString();
            _ShortDesc = drc[0]["ShortDescription"].ToString();
            _FullDesc = drc[0]["FullDescription"].ToString();
            _DocumentUpload = drc[0]["DocumentUploaded"].ToString();
            _SubmittedBy = drc[0]["SubmittedBy"].ToString();
            _SubmittedDate = Convert.ToDateTime(drc[0]["SubmittedDate"].ToString());
            _KeyWords = drc[0]["KeyWords"].ToString();
            StatusName = drc[0]["StatusName"].ToString();
            CategoryName = drc[0]["CategoryName"].ToString();
        }
        else
        {
            _DocumentTitle = "";
            _ShortDesc = "";
            _FullDesc = "";
            _DocumentUpload = "";
            _SubmittedBy = "";
            _KeyWords = "";
            StatusName = "";
            CategoryName = "";
        }

    }

    public void AddDocument()
    {
        SqlParameter[] p = new SqlParameter[10];
        p[0] = new SqlParameter("@StatusId", SqlDbType.Int);
        p[0].Value = _StatusId;

        p[1] = new SqlParameter("@CategoryId", SqlDbType.Int);
        p[1].Value = _CategoryId;

        p[2] = new SqlParameter("@DocumentTitle", SqlDbType.VarChar);
        p[2].Value = _DocumentTitle;

        p[3] = new SqlParameter("@ShortDesc", SqlDbType.VarChar);
        p[3].Value = _ShortDesc;

        p[4] = new SqlParameter("@FullDesc", SqlDbType.VarChar);
        p[4].Value = _FullDesc;

        p[5] = new SqlParameter("@DocumentUpload", SqlDbType.VarChar);
        p[5].Value = _DocumentUpload;

        p[6] = new SqlParameter("@SubmittedBy", SqlDbType.VarChar);
        p[6].Value = _SubmittedBy;

        p[7] = new SqlParameter("@SubmittedDate", SqlDbType.DateTime);
        p[7].Value = _SubmittedDate;

        p[8] = new SqlParameter("@Keywords", SqlDbType.VarChar);
        p[8].Value = _KeyWords;

        p[9] = new SqlParameter("@UserId", SqlDbType.Int);
        p[9].Value = _UserId;
        SqlHelper.ExecuteNonQuery(ClsConnectionString.getConnectionString(), CommandType.StoredProcedure, "spAddDocument", p);
    }
    public void UpdateDocument()
    {
        SqlParameter[] p = new SqlParameter[8];
        p[0] = new SqlParameter("@StatusId", SqlDbType.Int);
        p[0].Value = _StatusId;

        p[1] = new SqlParameter("@CategoryId", SqlDbType.Int);
        p[1].Value = _CategoryId;

        p[2] = new SqlParameter("@DocumentTitle", SqlDbType.VarChar);
        p[2].Value = _DocumentTitle;

        p[3] = new SqlParameter("@ShortDesc", SqlDbType.VarChar);
        p[3].Value = _ShortDesc;

        p[4] = new SqlParameter("@FullDesc", SqlDbType.VarChar);
        p[4].Value = _FullDesc;

        p[5] = new SqlParameter("@DocumentUpload", SqlDbType.VarChar);
        p[5].Value = _DocumentUpload;

       
        p[6] = new SqlParameter("@KeyWords", SqlDbType.VarChar);
        p[6].Value = _KeyWords;

        p[7] = new SqlParameter("@DocumentId", SqlDbType.Int);
        p[7].Value = _DocumentId;

        SqlHelper.ExecuteNonQuery(ClsConnectionString.getConnectionString(), CommandType.StoredProcedure, "spUpdateDocument", p);
    
    }
    public void DeleteDocument(string DocumentId)
    {
        string strSql = string.Empty;
        strSql += "delete from tbl_DocumentDetails";
        strSql += " where DocumentId in('" + DocumentId.Replace(",", "','") + "')";
        SqlHelper.ExecuteNonQuery(ClsConnectionString.getConnectionString(), CommandType.Text, strSql);
    }
    public void DeleteDocumentfile(int DocumentId)
    
    {
        string strSql = string.Empty;
        strSql += "Update tbl_DocumentDetails set DocumentUploaded='' where DocumentId=" + DocumentId;
        SqlHelper.ExecuteNonQuery(ClsConnectionString.getConnectionString(), CommandType.Text, strSql);
    }

    
}
