using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Users_frmMyDocuments : System.Web.UI.Page
{
    clsDocuments_Logic objDocument = new clsDocuments_Logic();
    clsUser_Logic objUser = new clsUser_Logic();
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsCategory_Logic objCategory = new clsCategory_Logic();
    private string strError = "No Data Available";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["UserName"] == null)
        {
            Response.Redirect("~/Default.aspx");
        }
        
        if (!Page.IsPostBack)
        {
            this.txtPageSize.Text = "10";

            BindCategory();
            BindStatus();

            BindData();
        }
        string Msg = "Do you want to delete this data?";
        btnDelete.Attributes.Add("onClick", "return confirm('" + Msg + "');");
    }
    void BindCategory()
    {
        DataSet dsCategory = objCategory.GetCategory();
        ddlCategory.DataSource = dsCategory.Tables[0];
        ddlCategory.DataTextField = "CategoryName";
        ddlCategory.DataValueField = "CategoryId";
        ddlCategory.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlCategory.Items.Insert(0, li);
    }
  
    void BindStatus()
    {
        DataSet dsStatus = objCommon.GetStatusName();
        ddlStatus.DataSource = dsStatus.Tables[0];
        ddlStatus.DataTextField = "StatusName";
        ddlStatus.DataValueField = "StatusId";
        ddlStatus.DataBind();
        ListItem li = new ListItem("Select", "0");
        ddlStatus.Items.Insert(0, li);
    }
    void BindData()
    {
        objDocument.DocumentTitle = txtDocumentTitle.Text.Trim();
        objDocument.CategoryId = Convert.ToInt32(ddlCategory.SelectedItem.Value.ToString());
        objDocument.StatusId = Convert.ToInt32(ddlStatus.SelectedItem.Value.ToString());
        objDocument.UserId=Convert.ToInt32(Session["UserId"].ToString());
        objDocument.Sort_On = "";
        if (ViewState["Sort_On"] != null)
            objDocument.Sort_On = ViewState["Sort_On"].ToString() + " " + ViewState["Sort_By"].ToString();
        lblError.Visible = false;
        DataSet dsTemp = objDocument.GetDocument();
        DataTable dtTemp = dsTemp.Tables[0];
        if (dtTemp.Rows.Count > 0)
        {
            lblError.Visible = false;
            btnDelete.Visible = true;
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = strError;
            btnDelete.Visible = false;
        }
        if (this.txtPageSize.Text != "")
        {
            if (System.Convert.ToInt32(this.txtPageSize.Text) > 0)
            {
                this.gvDocument.PageSize = System.Convert.ToInt32(this.txtPageSize.Text);
            }
        }
        gvDocument.DataSource = dtTemp;
        gvDocument.DataBind();
        if (dtTemp.Rows.Count == 0)
        {
            this.Lbl_Pageinfo.Visible = false;
        }
        else
        {
            Int16 intTo;
            Int16 intFrom;
            if (gvDocument.PageSize * (gvDocument.PageIndex + 1) < dtTemp.Rows.Count)
            {
                intTo = System.Convert.ToInt16(gvDocument.PageSize * (gvDocument.PageIndex + 1));
            }
            else
            {
                intTo = System.Convert.ToInt16(dtTemp.Rows.Count);
            }
            intFrom = System.Convert.ToInt16((gvDocument.PageSize * gvDocument.PageIndex) + 1);
            this.Lbl_Pageinfo.Text = "Record(s) " + intFrom + " to " + intTo + " of " + dtTemp.Rows.Count;
            this.Lbl_Pageinfo.Visible = true;
        }
    }

    protected void btnSearch_Click(object sender, EventArgs e)
    {
        strError = "No data matching with your searching criteria";
        gvDocument.PageIndex = 0;
        BindData();
    }
    protected void btndelete_Click(object sender, EventArgs e)
    {
        try{
        if (Request["Cbx_DocumentId"] == null)
        {
            lblError.Text = "Please select at least one to delete.";
            lblError.Visible = true;
        }
        else
        {
            objDocument.DeleteDocument(Request["Cbx_DocumentId"].ToString());
            lblError.Visible = false;
            BindData();
        }
         }
        catch (Exception ex)
        {
            lblError.Text = ex.Message;
            lblError.Visible = true;
        }

    }
    protected void btnadd_Click(object sender, EventArgs e)
    {
        Response.Redirect("frmAddDocument.aspx");
    }
    protected void gvDocument_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        if (ViewState["Sort_On"] != null)
            objDocument.Sort_On = ViewState["Sort_On"].ToString();
        else
            objDocument.Sort_On = "";
        gvDocument.PageIndex = e.NewPageIndex;
        BindData();
    }
    protected void gvDocument_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName.ToUpper() == "UPDATE")
        {
            Response.Redirect("frmViewDocument.aspx?Id=" + e.CommandArgument.ToString());
        }
    }
    protected void gvDocument_Sorting(object sender, GridViewSortEventArgs e)
    {
        objDocument.Sort_On = e.SortExpression;
        ViewState["Sort_On"] = objDocument.Sort_On;
        if (ViewState["Sort_By"] == null)
            ViewState["Sort_By"] = "Asc";
        if (ViewState["Sort_By"].ToString() == "Asc")
        {
            ViewState["Sort_By"] = "Desc";
        }
        else
        {
            ViewState["Sort_By"] = "Asc";
        }

        BindData();
    }
}
