using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Users_frmUserHome : System.Web.UI.Page
{
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsUser_Logic objUser = new clsUser_Logic();
    clsUserType_Logic objUserType = new clsUserType_Logic();
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["UserName"] == null)
        {
            Response.Redirect("~/Default.aspx");
        }
        GMDatePkDOB.MaxDate = System.DateTime.Now;
        GMDatePkDOB.MinDate = System.DateTime.Now.AddYears(-100);
        if (!IsPostBack)
        {
            BindCountry();
            BindStatus();
            BindState();
            BindCity();
            BindUserTypes();
            BindDetails();
        }
        GMDatePkDOB.Attributes.Add("readonly", "readonly()");
    }

    public void BindCountry()
    {
        DataSet dsCountry = objCommon.GetCountryName();
        ddlCountry.DataSource = dsCountry.Tables[0];
        ddlCountry.DataTextField = "CountryName";
        ddlCountry.DataValueField = "CountryId";
        ddlCountry.DataBind();
        ddlCountry.Items.Insert(0, "Select");
    }
    public void BindState()
    {
        DataSet dsState = objCommon.GetStateName();
        ddlState.DataSource = dsState.Tables[0];
        ddlState.DataTextField = "StateName";
        ddlState.DataValueField = "StateId";
        ddlState.DataBind();
        ddlState.Items.Insert(0, "Select");
    }
    public void BindCity()
    {
        DataSet dsCity = objCommon.GetDistrictName();
        ddlCity.DataSource = dsCity.Tables[0];
        ddlCity.DataTextField = "CityName";
        ddlCity.DataValueField = "CityId";
        ddlCity.DataBind();
        ddlCity.Items.Insert(0, "Select");
    }

    public void BindStatus()
    {
        DataSet dsStatus = objCommon.GetStatusName();
        ddlStatus.DataSource = dsStatus.Tables[0];
        ddlStatus.DataTextField = "StatusName";
        ddlStatus.DataValueField = "StatusId";
        ddlStatus.DataBind();
        ddlStatus.Items.Insert(0, "Select");
    }

    public void BindUserTypes()
    {
        DataSet dsUserType = objUserType.GetUserType();
        ddlUserType.DataSource = dsUserType.Tables[0];
        ddlUserType.DataTextField = "Typename";
        ddlUserType.DataValueField = "UserTypeId";
        ddlUserType.DataBind();
        ddlUserType.Items.Insert(0, "Select");
    }
    
    protected void ddlCountry_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (ddlCountry.SelectedItem.Text != "Select")
        {
            objCommon.pro_CountryId = Convert.ToInt32(ddlCountry.SelectedItem.Value);
            BindState();
        }
    }
    protected void ddlState_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (ddlState.SelectedItem.Text != "Select")
        {
            objCommon.pro_StateId = Convert.ToInt32(ddlState.SelectedItem.Value);
            BindCity();
        }
    }

    void BindDetails()
    {

        objUser.UserId = Convert.ToInt32(Session["UserId"].ToString());
        objUser.GetUserDetails();
        txtUserName.Text = objUser.UserName;
        txtContactNo.Text = objUser.ContactNo;
        txtAddress.Text = objUser.Address;
        txtEmailid.Text = objUser.EmailId;
        GMDatePkDOB.Date = objUser.DOB;
        
        txtFirstName.Text = objUser.FirstName;
        txtMiidleName.Text = objUser.MiddleName;
        txtLastName.Text = objUser.LastName;
        txtQualification.Text = objUser.Qualification;
        int SexIndex = ddlSex.Items.IndexOf(ddlSex.Items.FindByText(objUser.Sex));
        if (SexIndex >= 0)
            ddlSex.Items[SexIndex].Selected = true;

        int StatusIndex = ddlStatus.Items.IndexOf(ddlStatus.Items.FindByValue(objUser.StatusId.ToString()));
        if (StatusIndex >= 0)
            ddlStatus.Items[StatusIndex].Selected = true;
        int CountryIndex = ddlCountry.Items.IndexOf(ddlCountry.Items.FindByValue(objUser.CountryId.ToString()));
        if (CountryIndex >= 0)
            ddlCountry.Items[CountryIndex].Selected = true;

        int StateIndex = ddlState.Items.IndexOf(ddlState.Items.FindByValue(objUser.StateId.ToString()));
        if (StateIndex >= 0)
            ddlState.Items[StateIndex].Selected = true;

        int CityIndex = ddlCity.Items.IndexOf(ddlCity.Items.FindByValue(objUser.CityId.ToString()));
        if (CityIndex >= 0)
            ddlCity.Items[CityIndex].Selected = true;

        int UserTypeIndex = ddlUserType.Items.IndexOf(ddlUserType.Items.FindByValue(objUser.UserTypeId.ToString()));
        if (UserTypeIndex >= 0)
            ddlUserType.Items[UserTypeIndex].Selected = true;
    }
    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        objUser.UserId =Convert.ToInt32( Session["UserId"].ToString());
        objUser.ContactNo = txtContactNo.Text.Trim();
        objUser.Address = txtAddress.Text.Trim();
        objUser.EmailId = txtEmailid.Text.Trim();
        objUser.CityId = Convert.ToInt32(ddlCity.SelectedItem.Value);
        objUser.CountryId = Convert.ToInt32(ddlCountry.SelectedItem.Value);
        objUser.StateId = Convert.ToInt32(ddlState.SelectedItem.Value);
        objUser.StatusId = Convert.ToInt32(ddlStatus.SelectedItem.Value);
        objUser.DOB = Convert.ToDateTime(GMDatePkDOB.Date);
        objUser.Sex = ddlSex.SelectedItem.Text;
        objUser.FirstName = txtFirstName.Text.Trim();
        objUser.MiddleName = txtMiidleName.Text.Trim();
        objUser.LastName = txtLastName.Text.Trim();
        objUser.UserTypeId = Convert.ToInt32(ddlUserType.SelectedItem.Value);
        objUser.Qualification = txtQualification.Text.Trim();
       
        objUser.UpdateUser();
        Response.Write("<script>alert('Your Profile has been updated Successfully')</script>");
        //Response.Redirect("frmMyAccountHome.aspx");
    }
   
}
