using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Drawing;
public partial class Admin_frmUserRegistration : System.Web.UI.Page
{
    clsCommon_Logic objCommon = new clsCommon_Logic();
    clsUser_Logic objUser = new clsUser_Logic();
    clsUserType_Logic objUserType = new clsUserType_Logic();
    protected void Page_Load(object sender, EventArgs e)
    {
        GMDatePkDOB.MaxDate = System.DateTime.Now;
        GMDatePkDOB.MinDate = System.DateTime.Now.AddYears(-100);
        if (!IsPostBack)
        {
            BindCountry();
            BindStatus();
            BindUserTypes();
        }
        GMDatePkDOB.Attributes.Add("readonly", "readonly()");
    }

    public void BindCountry()
    {
        DataSet dsCountry = objCommon.GetCountryName();
        ddlCountry.DataSource = dsCountry.Tables[0];
        ddlCountry.DataTextField = "CountryName";
        ddlCountry.DataValueField = "CountryId";
        ddlCountry.DataBind();
        ddlCountry.Items.Insert(0, "Select");
    }
    public void BindState()
    {
        DataSet dsState = objCommon.GetStateName();
        ddlState.DataSource = dsState.Tables[0];
        ddlState.DataTextField = "StateName";
        ddlState.DataValueField = "StateId";
        ddlState.DataBind();
        ddlState.Items.Insert(0, "Select");
    }
    public void BindCity()
    {
        DataSet dsCity = objCommon.GetDistrictName();
        ddlCity.DataSource = dsCity.Tables[0];
        ddlCity.DataTextField = "CityName";
        ddlCity.DataValueField = "CityId";
        ddlCity.DataBind();
        ddlCity.Items.Insert(0, "Select");
    }

    public void BindStatus()
    {
        DataSet dsStatus = objCommon.GetStatusName();
        ddlStatus.DataSource = dsStatus.Tables[0];
        ddlStatus.DataTextField = "StatusName";
        ddlStatus.DataValueField = "StatusId";
        ddlStatus.DataBind();
        ddlStatus.Items.Insert(0, "Select");
    }
    public void BindUserTypes()
    {
        DataSet dsUserType = objUserType.GetUserType();
        ddlUserType.DataSource = dsUserType.Tables[0];
        ddlUserType.DataTextField = "Typename";
        ddlUserType.DataValueField = "UserTypeId";
        ddlUserType.DataBind();
        ddlUserType.Items.Insert(0, "Select");
    }
    protected void btnSubmit_Click(object sender, EventArgs e)
    {
        objUser.UserName = txtUserName.Text.Trim();
        objUser.Password = txtPassword.Text.Trim();
        objUser.ContactNo = txtContactNo.Text.Trim();        
        objUser.Address = txtAddress.Text.Trim();
        objUser.EmailId = txtEmailid.Text.Trim();
        objUser.CityId = Convert.ToInt32(ddlCity.SelectedItem.Value);
        objUser.CountryId = Convert.ToInt32(ddlCountry.SelectedItem.Value);
        objUser.StateId = Convert.ToInt32(ddlState.SelectedItem.Value);
        objUser.DOB = Convert.ToDateTime(GMDatePkDOB.Date);
        objUser.Sex = ddlSex.SelectedItem.Text;
        objUser.FirstName = txtFirstName.Text.Trim();
        objUser.MiddleName = txtMiidleName.Text.Trim();
        objUser.LastName = txtLastName.Text.Trim();
        objUser.UserTypeId =Convert.ToInt32(ddlUserType.SelectedItem.Value);
        objUser.Qualification = txtQualification.Text.Trim();
        objUser.StatusId = Convert.ToInt32(ddlStatus.SelectedItem.Value);
       int i= objUser.AddUser();
       if (i == 1) 
       {
           Response.Redirect("frmRegisterSuccess.aspx");
       }
       if (i == -2)
       {
           lblerror.Text = "Sorry This user name is already existing please choose another username";
       }
    }
    protected void ddlCountry_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (ddlCountry.SelectedItem.Text != "Select")
        {
            objCommon.pro_CountryId = Convert.ToInt32(ddlCountry.SelectedItem.Value);
            BindState();
        }
    }

    protected void ddlState_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (ddlState.SelectedItem.Text != "Select")
        {
            objCommon.pro_StateId = Convert.ToInt32(ddlState.SelectedItem.Value);
            BindCity();
        }
    }
    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect("~/Default.aspx");
    }
    protected void lnkbtnCheckAvailability_Click(object sender, EventArgs e)
    {
        if (txtUserName.Text.Trim() != "")
        {
            objUser.UserName = txtUserName.Text.Trim();
            lblExistsMemberId.Visible = true;
            if (objUser.CheckUserName())
            {
                lblExistsMemberId.ForeColor = Color.Red;
                lblExistsMemberId.Text = "Sorry,Already a User is existing with this Name";
            }
            else
            {
                lblExistsMemberId.ForeColor = Color.Green;
                lblExistsMemberId.Text = "No User is existing with this Name.So You can use with this";
            }
        }
        else
        {
            lblExistsMemberId.Visible = true;
            lblExistsMemberId.ForeColor = Color.Red;
            lblExistsMemberId.Text = "Please enter the User Name";
        }
    }
   
}
